=begin comment

API League

API League is a Hub for World Class APIs.

The version of the OpenAPI document: 1.6.4
Contact: mail@apileague.com
Generated by: https://openapi-generator.tech

=end comment

=cut

#
# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# Do not edit the class manually.
# Ref: https://openapi-generator.tech
#
package WWW::OpenAPIClient::MathApi;

require 5.6.0;
use strict;
use warnings;
use utf8;
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::OpenAPIClient::ApiClient;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class = shift;
    my $api_client;

    if ($_[0] && ref $_[0] && ref $_[0] eq 'WWW::OpenAPIClient::ApiClient' ) {
        $api_client = $_[0];
    } else {
        $api_client = WWW::OpenAPIClient::ApiClient->new(@_);
    }

    bless { api_client => $api_client }, $class;

}


#
# convert_units_api
#
# Convert Units API
#
# @param double $source_amount The source amount. (required)
# @param string $source_unit The source unit. (required)
# @param string $target_unit The unit to which should be converted. (required)
# @param string $food_name An optional food name. For converting foods the food is relevant as they have different densities. (optional)
{
    my $params = {
    'source_amount' => {
        data_type => 'double',
        description => 'The source amount.',
        required => '1',
    },
    'source_unit' => {
        data_type => 'string',
        description => 'The source unit.',
        required => '1',
    },
    'target_unit' => {
        data_type => 'string',
        description => 'The unit to which should be converted.',
        required => '1',
    },
    'food_name' => {
        data_type => 'string',
        description => 'An optional food name. For converting foods the food is relevant as they have different densities.',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'convert_units_api' } = {
        summary => 'Convert Units API',
        params => $params,
        returns => 'ConvertUnitsAPI200Response',
        };
}
# @return ConvertUnitsAPI200Response
#
sub convert_units_api {
    my ($self, %args) = @_;

    # verify the required parameter 'source_amount' is set
    unless (exists $args{'source_amount'}) {
      croak("Missing the required parameter 'source_amount' when calling convert_units_api");
    }

    # verify the required parameter 'source_unit' is set
    unless (exists $args{'source_unit'}) {
      croak("Missing the required parameter 'source_unit' when calling convert_units_api");
    }

    # verify the required parameter 'target_unit' is set
    unless (exists $args{'target_unit'}) {
      croak("Missing the required parameter 'target_unit' when calling convert_units_api");
    }

    # parse inputs
    my $_resource_path = '/convert-units';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'source_amount'}) {
        $query_params->{'source-amount'} = $self->{api_client}->to_query_value($args{'source_amount'});
    }

    # query params
    if ( exists $args{'source_unit'}) {
        $query_params->{'source-unit'} = $self->{api_client}->to_query_value($args{'source_unit'});
    }

    # query params
    if ( exists $args{'target_unit'}) {
        $query_params->{'target-unit'} = $self->{api_client}->to_query_value($args{'target_unit'});
    }

    # query params
    if ( exists $args{'food_name'}) {
        $query_params->{'food-name'} = $self->{api_client}->to_query_value($args{'food_name'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(apiKey headerApiKey )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ConvertUnitsAPI200Response', $response);
    return $_response_object;
}

1;
